<!DOCTYPE HTML>
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (11.0.6) on Thu Feb 20 09:43:17 CET 2020 -->
<title>DipFactory (DIP :: Java Native Interface Library 5.7.0 API)</title>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<meta name="dc.created" content="2020-02-20">
<link rel="stylesheet" type="text/css" href="../../stylesheet.css" title="Style">
<link rel="stylesheet" type="text/css" href="../../jquery/jquery-ui.css" title="Style">
<script type="text/javascript" src="../../script.js"></script>
<script type="text/javascript" src="../../jquery/jszip/dist/jszip.min.js"></script>
<script type="text/javascript" src="../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
<!--[if IE]>
<script type="text/javascript" src="../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
<![endif]-->
<script type="text/javascript" src="../../jquery/jquery-3.3.1.js"></script>
<script type="text/javascript" src="../../jquery/jquery-migrate-3.0.1.js"></script>
<script type="text/javascript" src="../../jquery/jquery-ui.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="DipFactory (DIP :: Java Native Interface Library 5.7.0 API)";
        }
    }
    catch(err) {
    }
//-->
var data = {"i0":6,"i1":6,"i2":6,"i3":6,"i4":6,"i5":6,"i6":6,"i7":6,"i8":6};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],4:["t3","Abstract Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
var pathtoroot = "../../";
var useModuleDirectories = true;
loadScripts(document, 'script');</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<header role="banner">
<nav role="navigation">
<div class="fixedNav">
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a id="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/DipFactory.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../index-all.html">Index</a></li>
<li><a href="../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<ul class="navListSearch">
<li><label for="search">SEARCH:</label>
<input type="text" id="search" value="search" disabled="disabled">
<input type="reset" id="reset" value="reset" disabled="disabled">
</li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
</div>
<div class="navPadding">&nbsp;</div>
<script type="text/javascript"><!--
$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
//-->
</script>
</nav>
</header>
<!-- ======== START OF CLASS DATA ======== -->
<main role="main">
<div class="header">
<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">cern.dip</a></div>
<h2 title="Interface DipFactory" class="title">Interface DipFactory</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Known Implementing Classes:</dt>
<dd><code><a href="implementation/DipFactoryImp.html" title="class in cern.dip.implementation">DipFactoryImp</a></code>, <code><a href="mock/MockDipFactory.html" title="class in cern.dip.mock">MockDipFactory</a></code></dd>
</dl>
<hr>
<pre>public interface <span class="typeNameLabel">DipFactory</span></pre>
<div class="block">Dip (Data Interchange Protocol) is the publish/subscribe interface for the
 CERN inter-domain communication designed according to the requirements
 established by the LDIWG (LHC Data Interchange Working Group). <BR><BR>

 Factory Interface for DipPublication, DipSubscription and DipData objects.
 <P>
 Concrete implementations of this interface will require implementation specific
 parameters such as URL of the broker or naming service.
 They will normally be implemented as singletons and encapsulate the functionality of the
 Dip implementation.
 <P>
 About DIP:
 <P>
 DIP (Data Interchange Protocol) is the publish/subscribe interface for the
 CERN inter-domain communication designed according to the requirements
 established by the LDIWG (LHC Data Interchange Working Group). <BR><BR>
 <P>
 In this working group has been established that any communication between the
 independent CERN domains shall be exchanged via DIP. The information namespace
 shall be partitioned in topics, organised in a hierarchical way with the string
 "dip" and the string describing the domain name coming first. The remaining part
 of the topic namespace is under the responsibility of the domain.
 <p>
 For instance the energy of the LHC beam accelerator domain topic may be: "dip.acc.LHC.intensity"
 where "acc" is the accelerator domain.</div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ========== METHOD SUMMARY =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t3" class="tableTab"><span><a href="javascript:show(4);">Abstract Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Method</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code><a href="DipBrowser.html" title="interface in cern.dip">DipBrowser</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#createDipBrowser()">createDipBrowser</a></span>()</code></th>
<td class="colLast">
<div class="block">Create a browser object with which the namespace of 
 DIP may be viewed.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code><a href="DipData.html" title="interface in cern.dip">DipData</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#createDipData()">createDipData</a></span>()</code></th>
<td class="colLast">
<div class="block">Creates a new DipData object.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code><a href="DipPublication.html" title="interface in cern.dip">DipPublication</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#createDipPublication(java.lang.String,cern.dip.DipPublicationErrorHandler)">createDipPublication</a></span>&#8203;(java.lang.String&nbsp;topicName,
                    <a href="DipPublicationErrorHandler.html" title="interface in cern.dip">DipPublicationErrorHandler</a>&nbsp;handler)</code></th>
<td class="colLast">
<div class="block">Creates a new DipPublication object for the topic specified by topicName.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code><a href="DipSubscription.html" title="interface in cern.dip">DipSubscription</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#createDipSubscription(java.lang.String,cern.dip.DipSubscriptionListener)">createDipSubscription</a></span>&#8203;(java.lang.String&nbsp;topicName,
                     <a href="DipSubscriptionListener.html" title="interface in cern.dip">DipSubscriptionListener</a>&nbsp;listener)</code></th>
<td class="colLast">
<div class="block">Creates a new DipSubscription object for the topic specified by topicName.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#destroyDipPublication(cern.dip.DipPublication)">destroyDipPublication</a></span>&#8203;(<a href="DipPublication.html" title="interface in cern.dip">DipPublication</a>&nbsp;publication)</code></th>
<td class="colLast">
<div class="block">Destroys DipPublication object previously created by createDipPublication().</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#destroyDipSubscription(cern.dip.DipSubscription)">destroyDipSubscription</a></span>&#8203;(<a href="DipSubscription.html" title="interface in cern.dip">DipSubscription</a>&nbsp;subscription)</code></th>
<td class="colLast">
<div class="block">Destroys DipSubscription object previously created by createDipSubscription().</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>int</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getTimeout()">getTimeout</a></span>()</code></th>
<td class="colLast">
<div class="block">Get the write and connection timeout to be used for DIP communication.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setDNSNode(java.lang.String)">setDNSNode</a></span>&#8203;(java.lang.String&nbsp;nodeName)</code></th>
<td class="colLast">
<div class="block">Specifies the DNS to be used for the DIP communication.</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setTimeout(int)">setTimeout</a></span>&#8203;(int&nbsp;timeout)</code></th>
<td class="colLast">
<div class="block">Set the write and connection timeout to be used for DIP communication.</div>
</td>
</tr>
</table>
</li>
</ul>
</section>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ METHOD DETAIL ========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a id="setDNSNode(java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setDNSNode</h4>
<pre class="methodSignature">void&nbsp;setDNSNode&#8203;(java.lang.String&nbsp;nodeName)</pre>
<div class="block">Specifies the DNS to be used for the DIP communication. 
 This setting applies for both the publications and the subscriptions.
 This method shall be used prior the creation of subscriptions or publications 
 as these become active immediatly. Further calls will be ignored.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>nodeName</code> - name of the DNS to be used.</dd>
</dl>
</li>
</ul>
<a id="setTimeout(int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setTimeout</h4>
<pre class="methodSignature">void&nbsp;setTimeout&#8203;(int&nbsp;timeout)</pre>
<div class="block">Set the write and connection timeout to be used for DIP communication.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>timeout</code> - Timeout in seconds to be applied to new connections.</dd>
</dl>
</li>
</ul>
<a id="getTimeout()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getTimeout</h4>
<pre class="methodSignature">int&nbsp;getTimeout()</pre>
<div class="block">Get the write and connection timeout to be used for DIP communication.</div>
</li>
</ul>
<a id="createDipSubscription(java.lang.String,cern.dip.DipSubscriptionListener)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>createDipSubscription</h4>
<pre class="methodSignature"><a href="DipSubscription.html" title="interface in cern.dip">DipSubscription</a>&nbsp;createDipSubscription&#8203;(java.lang.String&nbsp;topicName,
                                      <a href="DipSubscriptionListener.html" title="interface in cern.dip">DipSubscriptionListener</a>&nbsp;listener)
                               throws <a href="DipException.html" title="class in cern.dip">DipException</a></pre>
<div class="block">Creates a new DipSubscription object for the topic specified by topicName. Data
 published on this topic, as well as abnormal events such as disconnections,
 will be delivered to the listener object.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>topicName</code> - name of the subscription topic</dd>
<dd><code>listener</code> - is user object which implements</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="DipException.html" title="class in cern.dip">DipException</a></code> - if the subscription cannot be created.</dd>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="DipSubscriptionListener.html" title="interface in cern.dip"><code>interface, used to receive data as well as the state of publication.</code></a></dd>
</dl>
</li>
</ul>
<a id="createDipPublication(java.lang.String,cern.dip.DipPublicationErrorHandler)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>createDipPublication</h4>
<pre class="methodSignature"><a href="DipPublication.html" title="interface in cern.dip">DipPublication</a>&nbsp;createDipPublication&#8203;(java.lang.String&nbsp;topicName,
                                    <a href="DipPublicationErrorHandler.html" title="interface in cern.dip">DipPublicationErrorHandler</a>&nbsp;handler)
                             throws <a href="DipException.html" title="class in cern.dip">DipException</a></pre>
<div class="block">Creates a new DipPublication object for the topic specified by topicName.
 This object can then be used to publish new data on the topic. The handler
 specified by this call is used to inform the Publication developer of any
 ansynchronous (errors which can not be directly associated with any DipPublication
 method call).</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>topicName</code> - name of the subscription topic - must be unique</dd>
<dd><code>handler</code> - - used for handling aysnch. DIP errors.</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="DipException.html" title="class in cern.dip">DipException</a></code> - if the publication cannot be created.</dd>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="DipPublicationErrorHandler.html" title="interface in cern.dip"><code>interface,</code></a></dd>
</dl>
</li>
</ul>
<a id="destroyDipSubscription(cern.dip.DipSubscription)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>destroyDipSubscription</h4>
<pre class="methodSignature">void&nbsp;destroyDipSubscription&#8203;(<a href="DipSubscription.html" title="interface in cern.dip">DipSubscription</a>&nbsp;subscription)
                     throws <a href="DipException.html" title="class in cern.dip">DipException</a></pre>
<div class="block">Destroys DipSubscription object previously created by createDipSubscription().</div>
<dl>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="DipException.html" title="class in cern.dip">DipException</a></code> - if the subscription is not found.</dd>
</dl>
</li>
</ul>
<a id="destroyDipPublication(cern.dip.DipPublication)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>destroyDipPublication</h4>
<pre class="methodSignature">void&nbsp;destroyDipPublication&#8203;(<a href="DipPublication.html" title="interface in cern.dip">DipPublication</a>&nbsp;publication)
                    throws <a href="DipException.html" title="class in cern.dip">DipException</a></pre>
<div class="block">Destroys DipPublication object previously created by createDipPublication().</div>
<dl>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="DipException.html" title="class in cern.dip">DipException</a></code> - if the subscription is not found.</dd>
</dl>
</li>
</ul>
<a id="createDipData()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>createDipData</h4>
<pre class="methodSignature"><a href="DipData.html" title="interface in cern.dip">DipData</a>&nbsp;createDipData()</pre>
<div class="block">Creates a new DipData object. DipData objects have to be created for publishing
 complex data.</div>
</li>
</ul>
<a id="createDipBrowser()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>createDipBrowser</h4>
<pre class="methodSignature"><a href="DipBrowser.html" title="interface in cern.dip">DipBrowser</a>&nbsp;createDipBrowser()</pre>
<div class="block">Create a browser object with which the namespace of 
 DIP may be viewed.</div>
</li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
</div>
</main>
<!-- ========= END OF CLASS DATA ========= -->
<footer role="contentinfo">
<nav role="navigation">
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a id="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/DipFactory.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../index-all.html">Index</a></li>
<li><a href="../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</nav>
<p class="legalCopy"><small>Copyright &#169; 2008&#x2013;2020 <a href="http://www.cern.ch/">CERN</a>. All rights reserved.</small></p>
</footer>
</body>
</html>
